/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-cob-grasp-generation-0.5.1-1precise-20150329-1450/obj-i686-linux-gnu/devel/share/cob_grasp_generation/msg/ShowGraspsGoal.msg
 *
 */


#ifndef COB_GRASP_GENERATION_MESSAGE_SHOWGRASPSGOAL_H
#define COB_GRASP_GENERATION_MESSAGE_SHOWGRASPSGOAL_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace cob_grasp_generation
{
template <class ContainerAllocator>
struct ShowGraspsGoal_
{
  typedef ShowGraspsGoal_<ContainerAllocator> Type;

  ShowGraspsGoal_()
    : object_name()
    , grasp_id(0)
    , sort_by_quality(false)  {
    }
  ShowGraspsGoal_(const ContainerAllocator& _alloc)
    : object_name(_alloc)
    , grasp_id(0)
    , sort_by_quality(false)  {
    }



   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _object_name_type;
  _object_name_type object_name;

   typedef int32_t _grasp_id_type;
  _grasp_id_type grasp_id;

   typedef uint8_t _sort_by_quality_type;
  _sort_by_quality_type sort_by_quality;




  typedef boost::shared_ptr< ::cob_grasp_generation::ShowGraspsGoal_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::cob_grasp_generation::ShowGraspsGoal_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct ShowGraspsGoal_

typedef ::cob_grasp_generation::ShowGraspsGoal_<std::allocator<void> > ShowGraspsGoal;

typedef boost::shared_ptr< ::cob_grasp_generation::ShowGraspsGoal > ShowGraspsGoalPtr;
typedef boost::shared_ptr< ::cob_grasp_generation::ShowGraspsGoal const> ShowGraspsGoalConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::cob_grasp_generation::ShowGraspsGoal_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::cob_grasp_generation::ShowGraspsGoal_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace cob_grasp_generation

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'shape_msgs': ['/opt/ros/hydro/share/shape_msgs/cmake/../msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'moveit_msgs': ['/opt/ros/hydro/share/moveit_msgs/cmake/../msg'], 'trajectory_msgs': ['/opt/ros/hydro/share/trajectory_msgs/cmake/../msg'], 'sensor_msgs': ['/opt/ros/hydro/share/sensor_msgs/cmake/../msg'], 'object_recognition_msgs': ['/opt/ros/hydro/share/object_recognition_msgs/cmake/../msg'], 'octomap_msgs': ['/opt/ros/hydro/share/octomap_msgs/cmake/../msg'], 'geometry_msgs': ['/opt/ros/hydro/share/geometry_msgs/cmake/../msg'], 'cob_grasp_generation': ['/tmp/buildd/ros-hydro-cob-grasp-generation-0.5.1-1precise-20150329-1450/obj-i686-linux-gnu/devel/share/cob_grasp_generation/msg'], 'actionlib_msgs': ['/opt/ros/hydro/share/actionlib_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::cob_grasp_generation::ShowGraspsGoal_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::cob_grasp_generation::ShowGraspsGoal_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::cob_grasp_generation::ShowGraspsGoal_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::cob_grasp_generation::ShowGraspsGoal_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::cob_grasp_generation::ShowGraspsGoal_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::cob_grasp_generation::ShowGraspsGoal_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::cob_grasp_generation::ShowGraspsGoal_<ContainerAllocator> >
{
  static const char* value()
  {
    return "7b01b540f64b10e866d31682b977d243";
  }

  static const char* value(const ::cob_grasp_generation::ShowGraspsGoal_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x7b01b540f64b10e8ULL;
  static const uint64_t static_value2 = 0x66d31682b977d243ULL;
};

template<class ContainerAllocator>
struct DataType< ::cob_grasp_generation::ShowGraspsGoal_<ContainerAllocator> >
{
  static const char* value()
  {
    return "cob_grasp_generation/ShowGraspsGoal";
  }

  static const char* value(const ::cob_grasp_generation::ShowGraspsGoal_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::cob_grasp_generation::ShowGraspsGoal_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======\n\
#goal definition\n\
string object_name\n\
int32 grasp_id\n\
bool sort_by_quality\n\
";
  }

  static const char* value(const ::cob_grasp_generation::ShowGraspsGoal_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::cob_grasp_generation::ShowGraspsGoal_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.object_name);
      stream.next(m.grasp_id);
      stream.next(m.sort_by_quality);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct ShowGraspsGoal_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::cob_grasp_generation::ShowGraspsGoal_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::cob_grasp_generation::ShowGraspsGoal_<ContainerAllocator>& v)
  {
    s << indent << "object_name: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.object_name);
    s << indent << "grasp_id: ";
    Printer<int32_t>::stream(s, indent + "  ", v.grasp_id);
    s << indent << "sort_by_quality: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.sort_by_quality);
  }
};

} // namespace message_operations
} // namespace ros

#endif // COB_GRASP_GENERATION_MESSAGE_SHOWGRASPSGOAL_H
